"""
B-ASIC test suite for Inputport
TODO: More info
"""
from b_asic import InputPort, Signal, SignalSource, SignalDestination, Addition
import pytest

@pytest.fixture
def signal():
    source = SignalSource(Addition(0), 1)
    dest = SignalDestination(Addition(1),2)
    return Signal(source, dest)

def test_connect_multple_signals(signal):
    """
    make sure we can only connect one signal to an input port
    """
    inp_port = InputPort(0)
    inp_port.connect(signal)

    # create new signal
    source = SignalSource(Addition(0), 3)
    dest = SignalDestination(Addition(1),4)
    new_signal = Signal(source, dest)

    inp_port.connect(new_signal)
    inp_port.signal_count() == 1
    assert inp_port.signals() == [new_signal]