"""
B-ASIC test suite for InputPort
TODO: More info
"""
from b_asic import OutputPort, Signal, SignalSource, SignalDestination, Addition
import pytest

@pytest.fixture
def signal():
    source = SignalSource(Addition(0), 1)
    dest = SignalDestination(Addition(1),2)
    return Signal(source, dest)

def test_connect_multiple_signals(signal):
    """
    make sure we can connect multiple signals to an output port
    """
    outp_port = OutputPort(0)
    outp_port.connect(signal)

    # create new signal
    source = SignalSource(Addition(0), 3)
    dest = SignalDestination(Addition(1),4)
    new_signal = Signal(source, dest)

    outp_port.connect(new_signal)
    outp_port.signal_count() == 2
    assert outp_port.signals() == [signal, new_signal]